/*
fluxy. A Realtime 2d Path Tracer
---
Copyright (C) 2008  Sebastian Mach (*1983)
seb@greenhybrid.net | http://greenhybrid.net
---
This program is free software: you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/
#ifndef LINELIST_H
#define LINELIST_H

#include <vector>
#include "line.h"
#include "intersection.h"

class LineList {
    private:
        struct FastLine{
            bool isLuminaire;
            float x, y, d_x, d_y;//, length;
            float n_x[2], n_y[2];
            Material material;
        };

        std::vector<Line> compile_lines;
        FastLine *lines; // TODO: seperate Color from Geometry
        unsigned int numLines;
        unsigned int numLuminaires;
    public:
        LineList();
        void beginSceneDefinition();
        void addLine( Line line );
        void endSceneDefinition();
        Intersection intersect( float x, float y, float d_x, float d_y ) const;
};


#include "linelist.cc.h"

#endif // LINELIST_H
